
%% Autotuning init values
% Activate pos plot or not
simIn.plot = 0; % 0 if not plotting 1 if plotting position during sim.
simIn.step_dist = 0; % Add step disturbance peak 20 s after 3 min
simIn.adap_w = 0;    % Activate adaptive omega
% Simulationtime default 5 min
Ts = 0.2;
simIn.offset = 120;
offset = simIn.offset/Ts;
simIn.time = 420;%simIn.offset + 300;
set_lev = 0; % If set new levels for sc 2
% Init weigthing levels
simIn.pos_weight= [0.2 0.3 0.5];
simIn.head_weight = [0.2 0.3 0.5];
simIn.lambda = [1, 1, 1];
% Setting heading ref
simIn.psi_d = 0;
optimale = 0;
pre_search1 = 0; % Perform pre_search scenario 1?
pre_search2 = 0; % Perform pre_search,scenario 2?
pre_search4 = 0; % Perform pre_search,scenario 4?
% Selecting GA or RB tuning
ga =0;
%GA_tuning
startTime = clock;
time = startTime(4:5)
%% Running loop with different scenariobs
for sc = 1:3
    if sc == 1
        % Define Sea state
        simIn.SeaState = 4;
        simIn.sea_type = 1; % 0 equals Longcrest waves, 1 equals Shortcrest
        simIn.Beta_c = 225; % Ocean current direction in deg
        simIn.V_c = 0.5;    % Ocean current speed in [m/s]
        simIn.w_surge = 0.1;% 0.25
        simIn.w_sway = 0.1; %0.25
        simIn.w_yaw = 0.1;  %0.25
        simIn.tau_min = [0, 0, 0];
        simIn.tau_max = [0.75, 0.75, 0.75];
        %% Setting levels
        [simIn.x_lim(1),simIn.x_lim(2),simIn.x_lim(3),...
            simIn.y_lim(1),simIn.y_lim(2),simIn.y_lim(3),...
            simIn.h_lim(1),simIn.h_lim(2),simIn.h_lim(3),...
            simIn.filter_w0] =...
                set_lev_filt(simIn.SeaState, 0.7, simIn.psi_d,simIn.lambda);
         sim('supply_',[0 simIn.time]);
        plot_pos_head_
        tau1_def_4 = tau1;
        tau2_def_4 = tau2;
        tau6_def_4 = tau6;
        if pre_search1
            pre_search
            disp('PI vs w for ss 4, with lambda = 1')
            simIn
            % Setting init bandwidth
            simIn.w_surge = 0.1;% 0.25
            simIn.w_sway = 0.1; %0.25
            simIn.w_yaw = 0.1;   %0.275
        else
           load omega_4_10
           omega_surge = omega(:,1)';
           surge_score = omega(:,2)';
           omega_sway = omega(:,3)';
           sway_score = omega(:,4)';
           omega_yaw  = omega(:,5)';
           yaw_score  = omega(:,6)';
        end
        
        if ga
            GA_tuning
        else
            RB_tuning
        end
        
        sim('supply_',[0 simIn.time]);        
        %% Saving control parameters
        w_init(sc,:) = [simIn.w_surge, simIn.w_sway, simIn.w_yaw];
        %% Saving tau
        tau1_pos = tau1;
        tau2_pos = tau2;
        tau6_pos = tau6;
        L_surge_pos(sc) = L_dtau(end,1);
        L_sway_pos(sc) = L_dtau(end,2);
        L_yaw_pos(sc) = L_dtau(end,3);
        plot_pos_head_
        xx = x.signals.values((offset+1):end,1);
        yy = y.signals.values((offset+1):end,1);
        psi_psi = psi.signals.values((offset+1):end,1);
        [simIn.x_lim(1),simIn.x_lim(2),simIn.x_lim(3),...
            simIn.y_lim(1),simIn.y_lim(2),simIn.y_lim(3),...
            simIn.h_lim(1),simIn.h_lim(2),simIn.h_lim(3)] =...
            set_lev_dev_2(0.6, simIn.x_lim(3),simIn.y_lim(3),simIn.h_lim(3),...
            simIn.psi_d, simIn.offset, xx, yy, psi_psi);
        sim('supply_',[0 simIn.time]);
        plot_pos_head_lev
        %%search_lev1_2
        disp('pos sea state 4')
        simIn
        if simIn.SeaState == 3
            simIn.tau_min = [0, 0, 0];
             simIn.tau_max = [0.3, 0.05, 0.25];
        elseif simIn.SeaState == 4
            simIn.tau_min = [0, 0, 0];
            simIn.tau_max = [0.75, 0.75, 0.75];
        end
        simIn.lambda = [0.5, 0.5, 0.5];
        if simIn.lambda(1) == 1
            simIn.w_surge = 0.1;% 0.25
            simIn.w_sway = 0.1; %0.25
            simIn.w_yaw = 0.1;  %0.25
        end
    elseif sc == 2
        simIn.SeaState = 5;
        simIn.sea_type = 1; % 0 equals Longcrest waves, 1 equals Shortcrest
        simIn.Beta_c = 225; % Ocean current direction in rad
        simIn.V_c = 0.5;    % Ocean current speed in [m/s]
        if simIn.SeaState == 4
            simIn.tau_min = [0.0, 0.0, 0.0];
            simIn.tau_max = [0.75, 0.75, 0.75];
        elseif simIn.SeaState == 5
            simIn.tau_min = [0.25, 0.25, 0.25];
            simIn.tau_max = [0.75, 0.75, 0.75];
        end
        [simIn.x_lim(1),simIn.x_lim(2),simIn.x_lim(3),...
            simIn.y_lim(1),simIn.y_lim(2),simIn.y_lim(3),...
            simIn.h_lim(1),simIn.h_lim(2),simIn.h_lim(3),...
            simIn.filter_w0] =...
                set_lev_filt(simIn.SeaState, 0.7, simIn.psi_d);
        
        sim('supply_',[0 simIn.time]);
        w_init(sc,:) = [simIn.w_surge, simIn.w_sway, simIn.w_yaw];
        plot_pos_head_lev
        tau1_pos = tau1;
        tau2_pos = tau2;
        tau6_pos = tau6;
        % saving score and gains
        L_surge_pos(sc) = L_dtau(end,1);
        L_sway_pos(sc) = L_dtau(end,2);
        L_yaw_pos(sc) = L_dtau(end,3);
    elseif sc == 3 % Default controller settings
        tau1_pos = tau1;
        tau2_pos = tau2;
        tau6_pos = tau6;
        simIn.w_surge = 0.1;% 0.25
        simIn.w_sway = 0.1; %0.25
        simIn.w_yaw = 0.1;  %0.275
        sim('supply_',[0 simIn.time]);
        plot_pos_head_
        tau1_def_5 = tau1;
        tau2_def_5 = tau2;
        tau6_def_5 = tau6;
        L_surge_pos(sc) = L_dtau(end,1);
        L_sway_pos(sc) = L_dtau(end,2);
        L_yaw_pos(sc) = L_dtau(end,3);
    end 
    % Finding PI vs bandwidth controller
    if sc < 3
        if ga ==  0
            if (pre_search2 && simIn.SeaState == 4) || (pre_search4 && simIn.SeaState == 5)
                pre_search
                % saving best gains
                w_opt_(sc,:) = [simIn.w_surge, simIn.w_sway, simIn.w_yaw];
                disp('PI vs w')
                simIn
            elseif ~pre_search2 && simIn.SeaState == 4
                load omega_4_5
                omega_surge = omega(:,1)';
                surge_score = omega(:,2)';
                omega_sway = omega(:,3)';
                sway_score = omega(:,4)';
                omega_yaw  = omega(:,5)';
                yaw_score  = omega(:,6)';
            elseif ~pre_search4 && simIn.SeaState == 5
                load omega_5_5
                omega_surge = omega(:,1)';
                surge_score = omega(:,2)';
                omega_sway = omega(:,3)';
                sway_score = omega(:,4)';
                omega_yaw  = omega(:,5)';
                yaw_score  = omega(:,6)';
            end
        end
        simIn.w_surge = w_init(sc,1);
        simIn.w_sway = w_init(sc,2);
        simIn.w_yaw = w_init(sc,3);
        %% Performing autotuning
        if ga
            GA_tuning
        else
            RB_tuning
        end
        sim('supply_',[0 simIn.time]);
        disp('Optimal tuning')
        simIn
        plot_pos_head_tau_perf
        w_rb_opt_(sc,:) = [simIn.w_surge, simIn.w_sway, simIn.w_yaw];
        L_surge(sc) = L_dtau(end,1);
        L_sway(sc) = L_dtau(end,2);
        L_yaw(sc) = L_dtau(end,3);   
    end
    % Calculation reduction in total movement length 
    if sc < 3
        L_su(sc) = ((L_surge_pos(sc)-L_surge(sc))/L_surge_pos(sc))*100;
        L_sw(sc) = ((L_sway_pos(sc)-L_sway(sc))/L_sway_pos(sc))*100;
        L_ya(sc) = ((L_yaw_pos(sc) - L_yaw(sc))/L_yaw_pos(sc))*100;
        L_tot(:,sc) = [L_su(sc);L_sw(sc);L_ya(sc)];
    elseif sc == 3
        L_su(sc-1) = ((L_surge_pos(sc)-L_surge(sc-1))/L_surge_pos(sc))*100;
        L_sw(sc-1) = ((L_sway_pos(sc)-L_sway(sc-1))/L_sway_pos(sc))*100;
        L_ya(sc-1) = ((L_yaw_pos(sc) - L_yaw(sc-1))/L_yaw_pos(sc))*100;
        L_tot(:,sc-1) = [L_su(sc-1);L_sw(sc-1);L_ya(sc-1)];
    end
    %Plotting tau against default tau
    if sc == 1
        tau_plot_1_2_def(tau1,tau1_def_4,tau2,tau2_def_4,tau6,tau6_def_4,offset)
    elseif sc == 3
        tau_plot_1_2_def(tau1_pos,tau1_def_5,tau2_pos,tau2_def_5,tau6_pos,tau6_def_5,offset)
    end
end
if sc > 1
 bar_fig_saving_tau(L_tot)
end
stopTime = clock;
time = stopTime(4:5)
elapsetime = round(etime(stopTime, startTime)/60)