%% Rule Based Tuning PI
clear score_J opt_score opt_w w_in
c = 1;
w_max = 0.5;%-w_min;%simIn.filter_w0 - w_min;
step_min = 0.01;
w_in(c,:) = [simIn.w_surge, simIn.w_sway, simIn.w_yaw];
% Search for each DOF
for dof = 1:3
    c = 1;
    step_w = 0.1;
    if dof == 1
        w_min = 0.03;
    elseif dof == 2
        w_min = 0.06;
    elseif dof == 3
        w_min = 0.06;
    end
    if simIn.lambda(dof) < 0.9 && (w_in(c,dof) - step_w) > w_min
        s_dir = -1;
    elseif simIn.lambda(dof) >= 0.9 && (w_in(c,dof) + step_w) > w_max
        s_dir = -1;
    else
        s_dir = 1;
    end
    sim('supply_',[0 simIn.time]);
    if dof ==1 
        opt_w = w_in(c,:);
        score_J(c,dof:3)=...
        [Jp_Jh_lev(end,dof)*simIn.lambda(dof) + JT_tau(end,1)*(1-simIn.lambda(dof)),...
         Jp_Jh_lev(end,dof+1)*simIn.lambda(dof+1) + JT_tau(end,2)*(1-simIn.lambda(dof+1)),...
         Jp_Jh_lev(end,dof+2)*simIn.lambda(dof+2) + JT_tau(end,3)*(1-simIn.lambda(dof+2))];
         opt_score(dof:3) = score_J(c,:);
         x_label = '\omega_n surge controller';
    elseif dof == 2
        w_in(c,dof) = simIn.w_sway;
        opt_w(dof) = w_in(c,dof);
        score_J(c,dof:3)=...
        [Jp_Jh_lev(end,dof)*simIn.lambda(dof) + JT_tau(end,dof)*(1-simIn.lambda(2)),...
         Jp_Jh_lev(end,dof+1)*simIn.lambda(dof+1) + JT_tau(end,dof+1)*(1-simIn.lambda(dof+1))];
         opt_score(dof:3) = score_J(c,dof:3);
         x_label = '\omega_n sway controller';
    elseif dof == 3
        w_in(c,dof) = simIn.w_yaw;
        opt_w(dof) = w_in(c,dof);
        score_J(c,dof:3)=...
        [Jp_Jh_lev(end,3)*simIn.lambda(dof) + JT_tau(end,3)*(1-simIn.lambda(dof))];
        opt_score(dof:3) = score_J(c,dof:3);
        x_label = '\omega_n yaw controller';
    end
    w_in_tmp = w_in(c,dof);
    optium = 0;
    f_turn = 0;     % first turn in search direction
    step_c = 0;
    jump = 0;
    % Search loop
    while (~optium)
        c = c+1;                % Counter for step
        step_c = step_c + 1;    % Counter for step in same direction
        % Set new controller parameter   
        w_in(c,dof) = w_in_tmp + step_w*s_dir;
        if dof == 1
            simIn.w_surge = w_in(c,1);
        elseif dof == 2
            simIn.w_sway = w_in(c,2);
        elseif dof == 3
            simIn.w_yaw = w_in(c,3);
        end
        % Run simulation with controller paramet
        sim('supply_',[0 simIn.time]);
        % Save score
        score_J(c,dof) =...
                Jp_Jh_lev(end,dof)*simIn.lambda(dof) + JT_tau(end,dof)*(1-simIn.lambda(dof));
        % Control if best score
        if score_J(c,dof) > opt_score(dof) || ( score_J(c,dof) == opt_score(dof) &&  w_in(c,dof) < opt_w(dof) )
           opt_score(dof) = score_J(c,dof);
           opt_w(dof) =  w_in(c,dof);
        end
        % Plot PI as a function of omega % uncomment if plot for each step
%        PI_omega_fig_2(x_label,w_in(1:c,dof),score_J(1:c,dof)),grid 
        % Turn conditions
        if f_turn == 0 
            if (score_J(c,dof) < (score_J(c-1,dof) - 0.5)) || (score_J(c,dof) < (opt_score(dof) - 0.5))
                     f_turn = 1;                                    % First turn executed 
                    [s_dir,step_w, step_c] = turn(s_dir, step_w);   % Turn and decrease case 2
            elseif (c > 2) && (score_J(c,dof) < score_J(c-1,dof)) && (score_J(c-1,dof) < score_J(c-2,dof)) 
                     f_turn = 1;                                    % First turn executed 
                    [s_dir,step_w, step_c] = turn(s_dir, step_w);   % Turn and decrease case 2
            end
            w_in_tmp = w_in(c,dof);
        else
            if score_J(c,dof) < score_J(c-1,dof); % Turn if score less than last score
                [s_dir,step_w, step_c] = turn(s_dir, step_w);       % Turn and decrease case 2
                jump = 0;
                w_in_tmp = w_in(c,dof);
            else
                if step_c == 1
                    if ( score_J(c,dof) <= score_J(c-2,dof) )
                        w_in_tmp = w_in(c,dof) + step_w*s_dir;      % Jump over step case 4
                        jump = 1;
                    else                                   
                        step_w = step_w*0.5;                        % decrease step
                        w_in_tmp = w_in(c,dof);                     % continue direction case 3
                        jump = 0;
                    end
                else
                    if jump && ( w_in(c,dof) ~= opt_w(dof) )...
                            && ( sign(opt_w(dof) - w_in(c,dof) ) ~= s_dir)%( score_J(c,dof) < opt_score(dof) )
                        [s_dir,step_w, step_c] = turn(s_dir, step_w);           % Turn and decrease case 2
                        jump = 0;
                        w_in_tmp = w_in(c,dof);
                    else % Control if has been on point before
                        w_in(c+1,dof) = w_in(c,dof) + step_w*s_dir;
                        if visited(w_in(:,dof),c+1);
                            if score_J(c,dof) == opt_score(dof)... 
                                || score_J(c,dof) > score_J(c-1,dof)
                                step_w = step_w*0.5;                            % decrease step
                                w_in_tmp = w_in(c,dof);                         % continue direction case 3
                                jump = 0;
                            else
                                w_in_tmp = w_in(c,dof) + step_w*s_dir;          % jump over case 4
                                jump = 1;
                            end
                        else
                            w_in_tmp = w_in(c,dof);                             % continue direction case 1
                            jump = 0;
                        end
                    end
                end
            end           
        end
        % control that w_min < w_in(c+1,dof) < w_max if not case 4
        w_in(c+1,dof) = w_in_tmp + step_w*s_dir;
        if w_in(c+1,dof) > w_max || w_in(c+1,dof) < w_min
            if ( w_in(c+1,dof) > w_max ) && ( w_in(c+1,dof) - w_max <  step_w*0.5 )...
               || ( w_in(c+1,dof) < w_min ) && ( w_min - w_in(c+1,dof) <  step_w*0.5 )...
                    step_w = step_w*0.5;                                        % decrease step case  3
            else
                   [s_dir,step_w, step_c] = turn(s_dir, step_w);                % Turn and decrease case 2
                   if f_turn == 0
                       f_turn = 1;
                   end
            end
            jump = 0;
            w_in_tmp = w_in(c,dof);            
        end
        % Control if checked both side of w_opt with minimum stepsize
        if step_w < step_min %&& score_J(c,dof) ~= opt_score(dof)
            z = 0;
            done_ = 1;
            while z < 2
                z = z +1;               
                w_in(c+1,dof) = opt_w(dof) + 2*step_w*s_dir;                                    %w_in(c,dof) + 4*step_w*s_dir;
                if ~visited(w_in(:,dof),c+1);% opt_hit
                    done_ = 0;
                    z = 2;
                end
                if done_
                    s_dir = s_dir*-1;
                elseif ~done_ && (w_in(c+1,dof) > w_min && w_in(c+1,dof) < w_max) 
                    step_w = step_w*2;                              % increase step
                    w_in_tmp = opt_w(dof);                          % jump to opt
                end
            end            
        end
        if step_w < step_min || opt_score(dof) == 100% w_in(c,dof) >= w_max || w_in(c,dof) <= w_min ||
           optium = 1;
           simIn.w_surge = opt_w(1);
           simIn.w_sway = opt_w(2);
           simIn.w_yaw = opt_w(3);
        end
    end
    % Plot
    if dof == 1
        PI_omega_fig_2(x_label,w_in(1:c,dof),score_J(1:c,dof),omega_surge,surge_score),grid
        simIn.surge_opt = opt_score(dof);
    elseif dof == 2
        PI_omega_fig_2(x_label,w_in(1:c,dof),score_J(1:c,dof),omega_sway,sway_score),grid
        simIn.sway_opt = opt_score(dof);
    elseif dof == 3
        PI_omega_fig_2(x_label,w_in(1:c,dof),score_J(1:c,dof),omega_yaw,yaw_score),grid
        simIn.yaw_opt = opt_score(dof);
    end

end

