function head_perf_fig(c,psi,offset,H1Str,H2Str,H3Str,JhStr,JtyaStr,seaState,weight,w_yaw)

figure2 = figure('PaperSize',[20.98 29.68]);
X_c = [psi.time(offset), psi.time(end)];
Y_c(:,:) = [c(1), c(1);
            c(2), c(2);
            c(3), c(3)];

plot(psi.time,psi.signals.values(:,1),'b',...
    X_c,-Y_c(1,:),'g--',X_c,Y_c(1,:),'g--',...
    X_c,-Y_c(2,:),'y--',X_c,Y_c(2,:),'y--',...
    X_c,-Y_c(3,:),'r--',X_c,Y_c(3,:),'r--'),
xlabel('Time [min]'),ylabel('\psi [deg]'),
ylim([-c(3)-0.5 c(3)+0.5]),
xlim(X_c),
set(gca,'XTick',psi.time(offset):60:psi.time(end))
lables = ceil(psi.time(end)/psi.time(offset)) + 2;
switch lables
    case 3
        set(gca,'XTickLabel',{'0','1 min','2 min'})
    case 4
        set(gca,'XTickLabel',{'0','1 min','2 min','3 min'})
    case 5
        set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min'})
    case 6
        set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min', '5 min'})
end
title('Heading Performance','FontWeight','demi');

if nargin > 3
    annotation(figure2,'textbox',...
        'String',{H1Str,H2Str,H3Str},...
        'FitBoxToText','on',...
        'Position',[0.15 0.77 0.18 0.148]);
end
if nargin > 6
    annotation(figure2,'textbox',...
        'String',{JhStr,JtyaStr},...
        'FitBoxToText','on',...
        'Position',[0.7 0.79 0.19 0.13]);
end
if nargin > 8
    annotation(figure2,'textbox',...
        'String',{seaState,weight,w_yaw},...
        'FitBoxToText','on',...
        'Position',[0.42 0.77 0.2 0.148]);
end