%% Clear data setting step size
clear  surge_score sway_score yaw_score omega_surge omega_sway omega_yaw omega
Save_data = 1;
step_bw = 0.0125;
offset = simIn.offset/Ts;
%% Search for optimale bandwith in surge
simIn.w_surge = 0.5;
k = 0;
while simIn.w_surge > 0.025
    simIn.w_surge = simIn.w_surge - step_bw;
    sim('supply_',[0 simIn.time]);
    score = Jp_Jh_lev(end,1)*simIn.lambda(1) + JT_tau(end,1)*(1-simIn.lambda(1));
    k = k +1;
    omega_surge(k) = simIn.w_surge;
    surge_score(k) = score;
end
[c,I] = max(surge_score);
simIn.surge_opt = c;
simIn.w_surge = omega_surge(I);
%PI_omega_fig(omega_surge(1:k),surge_score(1:k)),grid

%% Search for optimale bandwith in sway
simIn.w_sway = 0.5;
k = 0;
while simIn.w_sway > 0.025
    simIn.w_sway = simIn.w_sway - step_bw;
    sim('supply_',[0 simIn.time]);
    score = Jp_Jh_lev(end,2)*simIn.lambda(2) + JT_tau(end,2)*(1-simIn.lambda(2));
    k = k +1;
    omega_sway(k) = simIn.w_sway;
    sway_score(k) = score;
end
[c,I] = max(sway_score);
simIn.sway_opt = c;
simIn.w_sway = omega_sway(I);
%PI_omega_fig(omega_sway(1:k),sway_score(1:k)),grid

%% Search for optimale bandwith in yaw
simIn.w_yaw = 0.5;
k = 0;
while simIn.w_yaw > 0.025
    simIn.w_yaw = simIn.w_yaw - step_bw;
    sim('supply_',[0 simIn.time]);
    score = Jp_Jh_lev(end,3)*simIn.lambda(3) + JT_tau(end,3)*(1-simIn.lambda(3));
    k = k +1;
    omega_yaw(k) = simIn.w_yaw;
    yaw_score(k) = score;
end
[c,I] = max(yaw_score);
simIn.yaw_opt = c;
simIn.w_yaw = omega_yaw(I);
%PI_omega_fig(omega_yaw(1:k),yaw_score(1:k)),grid

%% Plot optimal PI setting optimale controller parameters
[c,I] = max(surge_score);
simIn.w_surge = omega_surge(I);
[c,I] = max(sway_score);
simIn.w_sway = omega_sway(I);
[c,I] = max(yaw_score);
simIn.w_yaw = omega_yaw(I);
% sim('supply_3_GA',[0 simIn.time]);
% plot_pos_head_tau_perf
if Save_data
    omega(:,:) = [omega_surge',surge_score',omega_sway',sway_score',omega_yaw',yaw_score'];
    lambda = num2str(simIn.lambda(1)*10);
    SS = num2str(simIn.SeaState);
        str = ['omega_',SS,'_',lambda,'.mat'];
    save(str, 'omega');
end