function [level1_Xpos, level2_Xpos, level3_Xpos,...
    level1_Ypos, level2_Ypos, level3_Ypos,...
    level1_Head, level2_Head, level3_Head] = ...
    set_lev_dev_2(gamma, level3_Xpos, level3_Ypos,...
    level3_Head, psi_d, offset, xx, yy, psi_psi)
% function setting levels based on max deviation

x_lim_tmp = max(abs(xx));
y_lim_tmp = max(abs(yy));
dev_radius_tmp = 0;
for n = 1:length(psi_psi)
    % NED fixed
    radius(n) = sqrt((xx(n))^2 + (yy(n))^2);
    if xx(n) == 0
        theta(n) = pi/2;
    else
        theta(n) = atan2(xx(n),yy(n));
    end
    radius_tmp(n) = (x_lim_tmp*y_lim_tmp)/...
    sqrt(y_lim_tmp^2*sin(theta(n))^2+x_lim_tmp^2*cos(theta(n))^2);
    dev_radius = radius(n) - radius_tmp(n);
    if dev_radius > 0 && dev_radius > dev_radius_tmp
        dev_radius_tmp = dev_radius;
    end
end
x_lim = x_lim_tmp + dev_radius_tmp;
y_lim = y_lim_tmp + dev_radius_tmp;
h_lim = max(abs(psi_psi));
%% Setting levels
dec = 100;
% Setting level 1
level1_Xpos = (ceil(x_lim*dec))/dec;
level1_Ypos = (ceil(y_lim*dec))/dec;
level1_Head = (ceil(h_lim*dec))/dec;
% Setting level 2 as a function of level 1 and 3
level2_Xpos = (ceil((level1_Xpos + gamma*(level3_Xpos -level1_Xpos))*dec)/dec);
level2_Ypos = (ceil((level1_Ypos + gamma*(level3_Ypos -level1_Ypos))*dec)/dec);
level2_Head = (ceil((level1_Head + gamma*(level3_Head -level1_Head))*dec)/dec);

