function [level1_Xpos, level2_Xpos, level3_Xpos,...
    level1_Ypos, level2_Ypos, level3_Ypos,...
    level1_Head, level2_Head, level3_Head, filter_w0]...
    = set_lev_filt(seaState,gamma, psi_d, weight)
% function sets default levels to simIn based on sea state and gamma

switch seaState
    case 1
        filter_w0 = 1.11;
        level3_Xpos = 0.75;
        level3_Ypos = 0.5;
        level3_Head = 0.3;
    case 2
        filter_w0 = 0.93;
        level3_Xpos = 1;
        level3_Ypos = 0.75;
        level3_Head = 0.5;
    case 3
        filter_w0 = 0.79;
        
        level1_Xpos = .5;
        level1_Ypos = .5;
        level1_Head = .25;
        
        level3_Xpos = 3;
        level3_Ypos = 2;
        level3_Head = 1.5;        
    case 4
        filter_w0 = 0.68;
        
        level1_Xpos = 1;
        level1_Ypos = 1;
        level1_Head = .5;
        
        level3_Xpos = 3;
        level3_Ypos = 2;
        level3_Head = 1.5;
        
    case 5
        filter_w0 = 0.6;
        
        level1_Xpos = 2.25;
        level1_Ypos = 1.25;
        level1_Head = 1;
        
        level3_Xpos = 3;
        level3_Ypos = 2;
        level3_Head = 1.5;
        
    case 6
        filter_w0 = 0.53;
        
        level1_Xpos = 3;
        level1_Ypos = 2;
        level1_Head = 1.5; 
        
        level3_Xpos = 5;
        level3_Ypos = 4;
        level3_Head = 3;
    case 7
        filter_w0 = 0.46;
        level3_Xpos = 20;
        level3_Ypos = 10;
        level3_Head = 10;        
    case 8
        filter_w0 = 0.39;
        level3_Xpos = 30;
        level3_Ypos = 15;
        level3_Head = 15;
    otherwise    
        filter_w0 = 1.29;
        level3_Xpos = 0.75;
        level3_Ypos = 0.5;
        level3_Head = 0.5+psi_d;
        level1_Xpos = .75;
        level1_Ypos = .75;
        level1_Head = .5;
end
% Setting level 2 as a function of level 1 and 3
level2_Xpos = level1_Xpos + gamma*(level3_Xpos -level1_Xpos);
level2_Ypos = level1_Ypos + gamma*(level3_Ypos -level1_Ypos);
level2_Head = level1_Head + gamma*(level3_Head -level1_Head);
