function tau_bal_plot(Jp,Jh,Jt_surge,Jt_sway,Jt_yaw)

dJ = [Jt_surge-Jp, Jt_sway-Jp, Jt_yaw-Jh];
X3 = [0 100];
Y3 = [50 50];
X4 = Y3;
Y4 = [0 50];%X3;
Y5 = [50, 100];
X1(1:3) = 0;
X2(1:3) = 0;
Y1(1:3) = 0;
Y2(1:3) = 0;
x_fill_1(1:3,1:4) = 0;
y_fill_1(1:3,1:4) = 0;
x_fill_2(1:3,1:4) = 0;
y_fill_2(1:3,1:4) = 0;
fillc_1 = ['g','g','g'];
fillc_2 = ['g','g','g'];
% Surge PI balance
for df = 1:3
    % for each DOF
    if dJ(df) > 50      % omrikon = [-90, -45>
        X1(df) = dJ(df) - 50;
        X2(df) = 100 - X1(df);
        Y1(df) = 100;
        Y2(df) = 0;
        x_fill_1(df,:) = [50, X1(df), 0, 0];
        y_fill_1(df,:) = [50, Y1(df), 100, 50];
        x_fill_2(df,:) = [50, X2(df), 100, 100];
        y_fill_2(df,:) = [50, Y2(df), 0, 50];
        fillc_1(df) = 'g';
        fillc_2(df) = 'r';
%         x_fill(df,:) = [X1(df), X2(df), 0, 0];
%         y_fill(df,:) = [Y1(df), Y2(df), 0, 100];        
    elseif dJ(df) < -50 % omrikon = [90, 45>
        X1(df) = -dJ(df) - 50;
        X2(df) = 100 - X1(df);
        Y1(df) = 0;
        Y2(df) = 100;
        x_fill_1(df,:) = [50, X1(df), 0, 0];
        y_fill_1(df,:) = [50, Y1(df), 0, 50];
        x_fill_2(df,:) = [50, X2(df), 100, 100];
        y_fill_2(df,:) = [50, Y2(df), 100, 50];
        fillc_1(df) = 'r';
        fillc_2(df) = 'g';        
%         x_fill(df,:) = [X1(df), X2(df), 100, 100];
%         y_fill(df,:) = [Y1(df), Y2(df), 100, 0];        
    else               % omrikon = <-45, 45>
        X1(df) = 0;
        X2(df) = 100;
        Y1(df) = dJ(df) + 50;
        Y2(df) = 100 - Y1(df);
        x_fill_1(df,:) = [0, X1(df), 50, 0];
        y_fill_1(df,:) = [50, Y1(df), 50, 50];
        x_fill_2(df,:) = [50, X2(df), 100, 50];
        y_fill_2(df,:) = [50, Y2(df), 50, 50];
        if dJ(df) > 0
            fillc_1(df) = 'g';
            if dJ(df) > 20
                fillc_2(df) = 'r';
            else
                fillc_2(df) = 'y';
            end
        else
            fillc_2(df) = 'g';
            if dJ(df) < -20
                fillc_1(df) = 'r';
            else
                fillc_1(df) = 'y';
            end
%         else
%             x_fill_1(df,:) = [0, X1(df), 50, 50];
%             y_fill_1(df,:) = [0, Y1(df), 50, 0];
%             x_fill_2(df,:) = [50, X2(df), 100, 50];
%             y_fill_2(df,:) = [50, Y2(df), 0, 0];
%             fillc_1(df) = 'g';
%             fillc_2(df) = 'g';
        end
%         x_fill(df,:) = [X1(df), X2(df), 100, 0];
%         y_fill(df,:) = [Y1(df), Y2(df), 0, 0];        
    end
end
figure1 = figure('PaperSize',[20.98 29.68]);
% Surge
subplot(311)
box('on');
hold on
    plot([X1(1),X2(1)],[Y1(1),Y2(1)],'k','LineWidth',1.5),
    fill(x_fill_1(1,:),y_fill_1(1,:),fillc_1(1),x_fill_2(1,:),y_fill_2(1,:),fillc_2(1)),
    plot(X3,Y3,'k:')
    plot(X4,Y4,'k','LineWidth',2),
    plot(X4,Y5,'k:','LineWidth',1),
    xlabel('J_{\tau surge}                                                J_p','FontWeight','bold'),
    ylabel('Surge','FontWeight','demi'),
    ylim([0 100]),
    xlim([0 100]),
    set(gca,'XTick',0:10:50),
    set(gca,'XTickLabel',{'-50 %','-60 %','-70 %','-80 %','-90 %','-100 %'});%,'-90 %','-80 %','-70 %','-60 %','-50 %'})    
    set(gca,'YTick',10:10:100),
    set(gca,'YTickLabel',{'-40 %','-30 %','-20 %','-10 %',' 0 %','+10 %','+20 %','+30 %','+40 %','+50 %'})
    title(['Performance balance ','J_{\tau} vs J_{p/h}'],'FontWeight','bold'),
%    fill([X1(1), 100],[Y1(1), Y2(1)],'r')
hold off
% Sway
subplot(312)
box('on');
hold on
    plot([X1(2),X2(2)],[Y1(2),Y2(2)],'k','LineWidth',1.5),
    fill(x_fill_1(2,:),y_fill_1(2,:),fillc_1(2),x_fill_2(2,:),y_fill_2(2,:),fillc_2(2)),
%     fill(x_fill(2,:),y_fill(2,:),'g'),
    plot(X3,Y3,'k:')
    plot(X4,Y4,'k','LineWidth',2),
    plot(X4,Y5,'k:','LineWidth',1),
    xlabel('J_{\tau sway}                                                J_p','FontWeight','bold'),
    ylabel('Sway','FontWeight','demi'),
    ylim([0 100]),
    xlim([0 100]),
    set(gca,'XTick',0:10:50),
    set(gca,'XTickLabel',{'-50 %','-60 %','-70 %','-80 %','-90 %','-100 %'});%,'-90 %','-80 %','-70 %','-60 %','-50 %'})    
    set(gca,'YTick',10:10:100),
    set(gca,'YTickLabel',{'-40 %','-30 %','-20 %','-10 %',' 0 %','+10 %','+20 %','+30 %','+40 %','+50 %'})
%     title('J_{\tau} vs J_p Performance','FontWeight','demi'),
hold off
% Yaw
subplot(313)
box('on');
hold on
plot([X1(3),X2(3)],[Y1(3),Y2(3)],'k','LineWidth',1.5),
    fill(x_fill_1(3,:),y_fill_1(3,:),fillc_1(3),x_fill_2(3,:),y_fill_2(3,:),fillc_2(3)),
%     fill(x_fill(3,:),y_fill(3,:),'g'),
    plot(X3,Y3,'k:')
    plot(X4,Y4,'k','LineWidth',2),
    plot(X4,Y5,'k:','LineWidth',1),
    xlabel('J_{\tau yaw}                                                J_h','FontWeight','bold'),
    ylabel('Yaw','FontWeight','demi'),
    ylim([0 100]),
    xlim([0 100]),
    set(gca,'XTick',0:10:50),
    set(gca,'XTickLabel',{'-50 %','-60 %','-70 %','-80 %','-90 %','-100 %'});%,'-90 %','-80 %','-70 %','-60 %','-50 %'})    
    set(gca,'YTick',10:10:100),
    set(gca,'YTickLabel',{'-40 %','-30 %','-20 %','-10 %',' 0 %','+10 %','+20 %','+30 %','+40 %','+50 %'})
%     title('J_{\tau} vs J_p Performance','FontWeight','demi'),
hold off
% Create textbox 60% surge
annotation(figure1,'textbox','String',{'+60 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.16 0.94 0.095 0.039]);
% Create textbox 60% sway
annotation(figure1,'textbox','String',{'+60 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.16 0.64 0.095 0.039]);
% Create textbox 60% yaw
annotation(figure1,'textbox','String',{'+60 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.16 0.34 0.095 0.039]);

% Create textbox 70% surge
annotation(figure1,'textbox','String',{'+70 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.24 0.94 0.095 0.039]);
% Create textbox 70% sway
annotation(figure1,'textbox','String',{'+70 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.24 0.64 0.095 0.039]);
% Create textbox 70% yaw
annotation(figure1,'textbox','String',{'+70 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.24 0.34 0.095 0.039]);

% Create textbox 80% surge
annotation(figure1,'textbox','String',{'+80 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.315 0.94 0.095 0.039]);
% Create textbox 80% sway
annotation(figure1,'textbox','String',{'+80 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.315 0.64 0.095 0.039]);
% Create textbox 80% yaw
annotation(figure1,'textbox','String',{'+80 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.315 0.34 0.095 0.039]);

% Create textbox 90% surge
annotation(figure1,'textbox','String',{'+90 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.39 0.94 0.095 0.039]);
% Create textbox 90% sway
annotation(figure1,'textbox','String',{'+90 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.39 0.64 0.095 0.039]);
% Create textbox 90% yaw
annotation(figure1,'textbox','String',{'+90 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.39 0.34 0.095 0.039]);

% Create textbox 100% surge
annotation(figure1,'textbox','String',{'+100 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.46 0.94 0.115 0.039]);
% Create textbox 100% sway
annotation(figure1,'textbox','String',{'+100 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.46 0.64 0.115 0.039]);
% Create textbox 100% yaw
annotation(figure1,'textbox','String',{'+100 %'},'FitBoxToText','off',...
    'LineStyle','none',...
    'Position',[0.46 0.34 0.115 0.039]);

% Create arrow
%annotation(figure1,'arrow',[0.2241 0.1314],[0.7794 0.7645],'HeadWidth',15);

% Create arrow
%annotation(figure1,'arrow',[0.1994 0.1329],[0.5186 0.5216],'HeadWidth',15);

% Create arrow
%annotation(figure1,'arrow',[0.2148 0.1297],[0.1878 0.1872],'HeadWidth',15);