function tau_plot_1_2_mod(tau1,tau1_pos,tau2,tau2_pos,tau6,tau6_pos,offset)
mean_tau1 = mean(tau1.signals.values(((offset+1):end),2));
mean_tau2 = mean(tau2.signals.values(((offset+1):end),2));
mean_tau6 = mean(tau6.signals.values(((offset+1):end),2));
mean_tau1_pos = mean(tau1_pos.signals.values(((offset+1):end),2));
mean_tau2_pos = mean(tau2_pos.signals.values(((offset+1):end),2));
mean_tau6_pos = mean(tau6_pos.signals.values(((offset+1):end),2));

figure4 = figure('PaperSize',[20.98 29.68]);

subplot(321)
    hold on
    plot(tau1.time((offset+1):end),tau1.signals.values(((offset+1):end),2),'b',...
        tau1.time((offset+1):end),tau1_pos.signals.values(((offset+1):end),2),'g--'),
    ylabel('\tau surge [%] (of max)'),
    ylim([-120 120]),
    xlim([tau1.time(offset) tau1.time(end)]),
    set(gca,'XTick',tau1.time(offset):60:tau1.time(end))
    lables = ceil(tau1.time(end)/tau1.time(offset)) + 2;
    switch lables
        case 3
            set(gca,'XTickLabel',{'0','1 min','2 min'})
        case 4
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min'})
        case 5
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min'})
        case 6
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min', '5 min'})
    end
   
    title('\tau optimal performance balance vs optimal Position','FontWeight','demi'),
    legend('force tuned','pos/head tuned'),grid;
    hold off

subplot(322)
    hold on
    plot([tau1.time(offset),tau1.time(end)],[mean_tau1, mean_tau1],'c-.','Linewidth',1),
    plot([tau2.time(offset),tau2.time(end)],[mean_tau1_pos, mean_tau1_pos],'m:','Linewidth',1),
    ylabel('mean \tau surge [%] (of max)'),
    ylim([-120 120]),
    xlim([tau1.time(offset) tau1.time(end)]),
    set(gca,'XTick',tau1.time(offset):60:tau1.time(end))
    lables = ceil(tau1.time(end)/tau1.time(offset)) + 2;
    switch lables
        case 3
            set(gca,'XTickLabel',{'0','1 min','2 min'})
        case 4
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min'})
        case 5
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min'})
        case 6
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min', '5 min'})
    end
    legend('mean force tuned','pos/head tuned'),grid
    hold off
subplot(323)
hold on
    plot(tau2.time((offset+1):end),tau2.signals.values(((offset+1):end),2),'b',...
        tau2.time((offset+1):end),tau2_pos.signals.values(((offset+1):end),2),'g--'),
    ylabel('\tau sway [%] (of max)'),
    ylim([-120 120]),
    xlim([tau2.time(offset) tau2.time(end)]),
    set(gca,'XTick',tau2.time(offset):60:tau2.time(end))
    lables = ceil(tau2.time(end)/tau2.time(offset)) + 2;
    switch lables
        case 3
            set(gca,'XTickLabel',{'0','1 min','2 min'})
        case 4
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min'})
        case 5
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min'})
        case 6
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min', '5 min'})
    end
    grid,
    hold off
subplot(324)
    plot([tau2.time(offset),tau2.time(end)],[mean_tau2, mean_tau2],'c-.','Linewidth',1),
    plot([tau2.time(offset),tau2.time(end)],[mean_tau2_pos, mean_tau2_pos],'m:','Linewidth',1),
    ylabel('mean \tau sway [%] (of max)'),
    ylim([-120 120]),
    xlim([tau1.time(offset) tau1.time(end)]),
    set(gca,'XTick',tau1.time(offset):60:tau1.time(end))
    lables = ceil(tau1.time(end)/tau1.time(offset)) + 2;
    switch lables
        case 3
            set(gca,'XTickLabel',{'0','1 min','2 min'})
        case 4
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min'})
        case 5
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min'})
        case 6
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min', '5 min'})
    end
    grid
    hold off
subplot(325)
    hold on
    plot(tau6.time((offset+1):end),tau6.signals.values(((offset+1):end),2),'b',...
        tau6.time((offset+1):end),tau6_pos.signals.values(((offset+1):end),2),'g--'),
    ylabel('\tau yaw [%] (of max)'),
    ylim([-120 120]),
        xlim([tau6.time(offset) tau6.time(end)]),
    set(gca,'XTick',tau6.time(offset):60:tau6.time(end))
    lables = ceil(tau6.time(end)/tau6.time(offset)) + 2;
    switch lables
        case 3
            set(gca,'XTickLabel',{'0','1 min','2 min'})
        case 4
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min'})
        case 5
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min'})
        case 6
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min', '5 min'})
    end
    grid
    hold off
subplot(326)
    hold on
    plot([tau2.time(offset),tau2.time(end)],[mean_tau6, mean_tau6],'c-.','Linewidth',1),
    plot([tau2.time(offset),tau2.time(end)],[mean_tau6_pos, mean_tau6_pos],'m:','Linewidth',1),
    ylabel('mean \tau yaw [%] (of max)'),
    ylim([-120 120]),
        xlim([tau6.time(offset) tau6.time(end)]),
    set(gca,'XTick',tau6.time(offset):60:tau6.time(end))
    lables = ceil(tau6.time(end)/tau6.time(offset)) + 2;
    switch lables
        case 3
            set(gca,'XTickLabel',{'0','1 min','2 min'})
        case 4
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min'})
        case 5
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min'})
        case 6
            set(gca,'XTickLabel',{'0','1 min','2 min','3 min','4 min', '5 min'})
    end
    grid
    hold off